# std::basic_string::at

From cppreference.com
< cpp‎ | string‎ | basic string

reference at( size_type pos ); |  |
const_reference at( size_type pos ) const; |  |

Returns a reference to the character at specified location `pos`. Bounds checking is performed, exception of type std::out_of_range will be thrown on invalid access.

### Parameters

pos | - | position of the character to return

### Return value

Reference to the requested character.

### Exceptions

Throws std::out_of_range if pos >= size().

### Complexity

Constant.

### Example

Run this code

    #include <stdexcept>
    #include <iostream>
    #include <string>

    int main()
    {
        std::string s("message"); // for capacity

        s = "abc";
        s.at(2) = 'x'; // ok
        std::cout << s << '\n';

        std::cout << "string size = " << s.size() << '\n';
        std::cout << "string capacity = " << s.capacity() << '\n';

        try {
            // throw, even if capacity allowed to access element
            s.at(3) = 'x';
        }
        catch (std::out_of_range const& exc) {
            std::cout << exc.what() << '\n';
        }
    }

Output:

    abx
    string size = 3
    string capacity = 7
    basic_string::at

### See also

operator[] | access specified character (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/at&oldid=70312"